/*
 * This software is the confidential and proprietary information of
 * Smardec. You shall not disclose or distribute such Confidential Information.
 * This software shall not be integrated, copied (partially or fully),
 * or reverse engineered into any other software, program, or code that is
 * not intended for Smardec. You shall use it only in accordance with the terms
 * of the license agreement you entered into with Smardec.
 *
 * Copyright (C) 2004-2006 Smardec. All rights reserved.
 *
 * http://www.smardec.com
 *
 */

package com.smardec.demo.j2native.win32.cdplayer;

import com.smardec.demo.j2native.tools.LibraryManager;
import com.smardec.j2native.*;

public class CDPlayer {
    private static final int IDStopBtn = 0;
    private static final int IDPrevBtn = 2;
    private static final int IDPlayBtn = 4;
    private static final int IDNextBtn = 8;
    private static final int IDDoorBtn = 10;

    private static final int WindowWidth = 220;
    private static final int WindowHeigth = 94;

    private static boolean registered;

    public boolean doorIsOpen;
    public boolean playing;
    public boolean paused;
    public boolean noDisc;
    public long numberOfTracks;
    public long currentTrack;
    public long totalLength;
    public long currentTrackLength;
    public long time;

    private boolean oddTick;
    private boolean initialized;
    private UInt deviceID;

    private Pointer.Void hImageList;
    private Pointer.Void hImageListLarge;
    private Pointer.Void hWndMain;
    private HWndBtn hWndBtn;
    private Pointer.Void hInst;
    private Pointer.Void hBitmapMain;
    private Pointer.Void hBitmapInfoBg;
    private Pointer.Void hTaskbarIcon;
    private UInt IDTimer;
    private boolean needRedraw;

    private TimerProc timerProc;

    private Function mciSendCommand;
    private Function messageBox;
    private Function redrawWindow;
    private Function invalidateRect;
    private Function createRoundRectRgn;
    private Function createEllipticRgn;
    private Function getLastError;
    private Function setWindowRgn;
    private Function loadImage;
    private Function imageList_Create;
    private Function imageList_Add;
    private Function deleteObject;
    private Function setWindowLong;
    private Function showWindow;
    private Function updateWindow;
    private Function systemParametersInfo;
    private Function setWindowPlacement;
    private Function setTimer;
    private Function getWindowDC;
    private Function createCompatibleDC;
    private Function selectObject;
    private Function bitBlt;
    private Function deleteDC;
    private Function releaseDC;
    private Function beginPaint;
    private Function endPaint;
    private Function postMessage;
    private Function setBkMode;
    private Function setBkColor;
    private Function setTextColor;
    private Function createFont;
    private Pointer fontName = new Pointer(new AnsiString("BitDust Two"));
    private Function textOut;
    private Function screenToClient;
    private Function isIconic;
    private Function setForegroundWindow;
    private Function imageList_Destroy;
    private Function killTimer;
    private Function postQuitMessage;
    private Function defWindowProc;
    private Function findWindow;
    private Function loadIcon;
    private Function loadCursor;
    private Function getStockObject;
    private Function registerClass;
    private Function createWindowEx;
    private Function getMessage;
    private Function translateMessage;
    private Function dispatchMessage;
    private Function initCommonControls;
    private Function shell_NotifyIcon;
    private Function createPolyPolygonRgn;

    public CDPlayer() {
        hImageList = new Pointer.Void();
        hImageListLarge = new Pointer.Void();
        hWndMain = new Pointer.Void();
        hInst = new Pointer.Void();
        hBitmapMain = new Pointer.Void();
        hBitmapInfoBg = new Pointer.Void();
        hTaskbarIcon = new Pointer.Void();
        IDTimer = new UInt();
        initialized = false;
    }

    public UInt getDeviceID() {
        return deviceID;
    }

    public Pointer.Void getHImageList() {
        return hImageList;
    }

    public Pointer.Void getHImageListLarge() {
        return hImageListLarge;
    }

    public Pointer.Void getHWndMain() {
        return hWndMain;
    }

    public HWndBtn getHWndBtn() {
        return hWndBtn;
    }

    public Pointer.Void getHBitmapMain() {
        return hBitmapMain;
    }

    public Pointer.Void getHTaskbarIcon() {
        return hTaskbarIcon;
    }

    public boolean initFunctions() {
        try {
            Library shell32 = new Library("shell32");
            LibraryManager.getInstance().registerLibrary(shell32);
            shell_NotifyIcon = shell32.getFunction("Shell_NotifyIconA");

            Library comctl32 = new Library("comctl32");
            LibraryManager.getInstance().registerLibrary(comctl32);
            imageList_Create = comctl32.getFunction("ImageList_Create");
            imageList_Add = comctl32.getFunction("ImageList_Add");
            imageList_Destroy = comctl32.getFunction("ImageList_Destroy");
            initCommonControls = comctl32.getFunction("InitCommonControls");

            Library winmm = new Library("winmm");
            LibraryManager.getInstance().registerLibrary(winmm);
            mciSendCommand = winmm.getFunction("mciSendCommandA");

            Library user32 = LibraryManager.getInstance().getLibrary("user32");
            messageBox = user32.getFunction("MessageBoxA");
            redrawWindow = user32.getFunction("RedrawWindow");
            invalidateRect = user32.getFunction("InvalidateRect");
            setWindowRgn = user32.getFunction("SetWindowRgn");
            loadImage = user32.getFunction("LoadImageA");
            setWindowLong = user32.getFunction("SetWindowLongA");
            showWindow = user32.getFunction("ShowWindow");
            updateWindow = user32.getFunction("UpdateWindow");
            systemParametersInfo = user32.getFunction("SystemParametersInfoA");
            setWindowPlacement = user32.getFunction("SetWindowPlacement");
            setTimer = user32.getFunction("SetTimer");
            getWindowDC = user32.getFunction("GetWindowDC");
            releaseDC = user32.getFunction("ReleaseDC");
            beginPaint = user32.getFunction("BeginPaint");
            endPaint = user32.getFunction("EndPaint");
            postMessage = user32.getFunction("PostMessageA");
            screenToClient = user32.getFunction("ScreenToClient");
            isIconic = user32.getFunction("IsIconic");
            setForegroundWindow = user32.getFunction("SetForegroundWindow");
            killTimer = user32.getFunction("KillTimer");
            postQuitMessage = user32.getFunction("PostQuitMessage");
            defWindowProc = user32.getFunction("DefWindowProcA");
            findWindow = user32.getFunction("FindWindowA");
            loadIcon = user32.getFunction("LoadIconA");
            loadCursor = user32.getFunction("LoadCursorA");
            registerClass = user32.getFunction("RegisterClassA");
            createWindowEx = user32.getFunction("CreateWindowExA");
            getMessage = user32.getFunction("GetMessageA");
            translateMessage = user32.getFunction("TranslateMessage");
            dispatchMessage = user32.getFunction("DispatchMessageA");

            Library gdi32 = LibraryManager.getInstance().getLibrary("gdi32");
            createRoundRectRgn = gdi32.getFunction("CreateRoundRectRgn");
            createEllipticRgn = gdi32.getFunction("CreateEllipticRgn");
            deleteObject = gdi32.getFunction("DeleteObject");
            createCompatibleDC = gdi32.getFunction("CreateCompatibleDC");
            selectObject = gdi32.getFunction("SelectObject");
            bitBlt = gdi32.getFunction("BitBlt");
            deleteDC = gdi32.getFunction("DeleteDC");
            setBkMode = gdi32.getFunction("SetBkMode");
            setBkColor = gdi32.getFunction("SetBkColor");
            setTextColor = gdi32.getFunction("SetTextColor");
            createFont = gdi32.getFunction("CreateFontA");
            textOut = gdi32.getFunction("TextOutA");
            getStockObject = gdi32.getFunction("GetStockObject");
            createPolyPolygonRgn = gdi32.getFunction("CreatePolyPolygonRgn");

            Library kernel32 = LibraryManager.getInstance().getLibrary("kernel32");
            getLastError = kernel32.getFunction("GetLastError");
        } catch (LibraryNotFoundException e) {
            e.printStackTrace();
            return false;
        } catch (FunctionNotFoundException e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }

    protected void initialize() {
        MCI_OPEN_PARMS MOP = new MCI_OPEN_PARMS();
        MOP.lpstrDeviceType.setValue(CDPConstants.MCI_DEVTYPE_CD_AUDIO);
        UInt errorCode = new UInt();
        mciSendCommand.invoke(errorCode, new UInt(0), new UInt(CDPConstants.MCI_OPEN),
                new UInt(CDPConstants.MCI_OPEN_TYPE | CDPConstants.MCI_OPEN_TYPE_ID),
                new Pointer(MOP));
        if (errorCode.intValue() != 0) {
            messageBox.invoke(null, new Pointer.Void(), new Pointer(new AnsiString("Unable to initialize CD Audio device")),
                    new Pointer(new AnsiString("Error")),
                    new UInt(CDPConstants.MB_OK | CDPConstants.MB_ICONERROR));
            return;
        }
        deviceID = (UInt) MOP.wDeviceID.clone();

        MCI_SET_PARMS setPar = new MCI_SET_PARMS();
        setPar.dwTimeFormat.setValue(CDPConstants.MCI_FORMAT_MILLISECONDS);
        mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_SET),
                new UInt(CDPConstants.MCI_SET_TIME_FORMAT), new Pointer(setPar));

        // loading font file
        try {
            Pointer filename = new Pointer(new AnsiString("img\\bitdust2.ttf"));
            Function function = LibraryManager.getInstance().getLibrary("gdi32").getFunction("AddFontResourceA");
            function.invoke(null, filename);
        } catch (Exception e) {
        }

        doorIsOpen = false;
        initialized = true;

/*
    MCI_OPEN_PARMS MOP;
    MOP.lpstrDeviceType=(char *)MCI_DEVTYPE_CD_AUDIO;
    if(mciSendCommand(0,MCI_OPEN,MCI_OPEN_TYPE_ID|MCI_OPEN_TYPE,(DWORD)(LPMCI_OPEN_PARMS)&MOP))
      MessageBox(NULL,"Unable to initialize CD Audio device","Error",MB_OK|MB_ICONERROR);
    DeviceID=MOP.wDeviceID;  //Save DeviceID

    MCI_SET_PARMS SetPar;
    SetPar.dwTimeFormat=MCI_FORMAT_MILLISECONDS;
    mciSendCommand(GetDeviceID(),MCI_SET,MCI_SET_TIME_FORMAT,(DWORD)&SetPar);
    DoorIsOpen=FALSE;
    Initialized=TRUE;
    mciSendCommand(GetDeviceID(),MCI_PLAY,0,0);
*/
    }

    public void invokeDestroy() {
        if (!initialized) {
            return;
        }
        postMessage.invoke(null, getHWndMain(), new UInt(CDPConstants.WM_CLOSE), new UInt(), new UInt());
    }

    protected void deinitialize() {
        if (!initialized) {
            return;
        }
        UInt errorCode = new UInt();
        mciSendCommand.invoke(errorCode, getDeviceID(), new UInt(CDPConstants.MCI_CLOSE), new UInt(0), new Pointer.Void());
        if (errorCode.intValue() != 0) {
            messageBox.invoke(null, getHWndMain(), new Pointer(new AnsiString("Unable to close CD Audio device")),
                    new Pointer(new AnsiString("Error")),
                    new UInt(CDPConstants.MB_OK | CDPConstants.MB_ICONERROR));
        }

        // unloading font file
        try {
            Pointer filename = new Pointer(new AnsiString("demo-resources\\winplayer\\bitdust2.ttf"));
            Function function = LibraryManager.getInstance().getLibrary("gdi32").getFunction("RemoveFontResourceA");
            function.invoke(null, filename);
        } catch (Exception e) {
        }

        initialized = false;
    }

    private boolean invert = true;

    public void eject() {
        if (!initialized) {
            return;
        }
        playing = false;

        redrawWindow.invoke(null, getHWndBtn().play, new Pointer.Void(),
                new Pointer.Void(), new UInt(CDPConstants.RDW_INVALIDATE));
        if (doorIsOpen && noDisc) {
            if (invert) {
                mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_SET),
                        new UInt(CDPConstants.MCI_SET_DOOR_OPEN), new Pointer.Void());
            } else {
                mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_SET),
                        new UInt(CDPConstants.MCI_SET_DOOR_CLOSED), new Pointer.Void());
            }
            invert = !invert;
            return;
        }
        if (doorIsOpen) {
            mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_SET),
                    new UInt(CDPConstants.MCI_SET_DOOR_CLOSED), new Pointer.Void());
            invert = true;
        } else {
            mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_SET),
                    new UInt(CDPConstants.MCI_SET_DOOR_OPEN), new Pointer.Void());
            invert = false;
        }
/*
  if(!Initialized) return;
  Playing=FALSE;
  RedrawWindow(hWndBtn.Play,0,0,RDW_INVALIDATE);
  if(DoorIsOpen)
    mciSendCommand(GetDeviceID(),MCI_SET,MCI_SET_DOOR_CLOSED,0);
  else
    mciSendCommand(GetDeviceID(),MCI_SET,MCI_SET_DOOR_OPEN,0);
*/
    }

    public void play() {
        if (!initialized) {
            return;
        }
        if (playing) {
            mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_PAUSE), new UInt(0), new Pointer.Void());
            paused = true;
        } else {
            mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_PLAY), new UInt(0), new Pointer.Void());
            paused = false;
        }
/*
  if(!Initialized) return;
  if(Playing){
    mciSendCommand(GetDeviceID(),MCI_PAUSE,0,0);
    Paused=TRUE;
  }
  else{
    mciSendCommand(GetDeviceID(),MCI_PLAY,0,0);
    Paused=FALSE;
  }
*/
    }

    public void stop() {
        if (!initialized) {
            return;
        }
        mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_STOP), new UInt(0), new Pointer.Void());
        mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_SEEK), new UInt(CDPConstants.MCI_SEEK_TO_START), new Pointer.Void());
        playing = paused = false;
        redrawWindow.invoke(null, getHWndBtn().play, new Pointer.Void(),
                new Pointer.Void(), new UInt(CDPConstants.RDW_INVALIDATE));
        needRedraw = true;
/*
  if(!Initialized) return;
  mciSendCommand(GetDeviceID(),MCI_STOP,0,0);
  mciSendCommand(GetDeviceID(),MCI_SEEK,MCI_SEEK_TO_START,0);
  Playing=Paused=FALSE;
  RedrawWindow(hWndBtn.Play,0,0,RDW_INVALIDATE);
  NeedRedraw=TRUE;
*/
    }

    public void next() {
        if (!initialized) {
            return;
        }
        boolean t = false;
        if (playing) {
            t = true;
        }
        mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_STOP), new UInt(0), new Pointer.Void());
        mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_SEEK), new UInt(CDPConstants.MCI_SEEK_TO_START), new Pointer.Void());
        MCI_SET_PARMS setPar = new MCI_SET_PARMS();
        setPar.dwTimeFormat.setValue(CDPConstants.MCI_FORMAT_TMSF);
        mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_SET),
                new UInt(CDPConstants.MCI_SET_TIME_FORMAT), new Pointer(setPar));
        currentTrack++;
        if (currentTrack > numberOfTracks) {
            currentTrack -= numberOfTracks;
        }
        MCI_SEEK_PARMS seekPar = new MCI_SEEK_PARMS();
        seekPar.dwTo.setValue(currentTrack);
        mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_SEEK),
                new UInt(CDPConstants.MCI_TO), new Pointer(seekPar));
        setPar.dwTimeFormat.setValue(CDPConstants.MCI_FORMAT_MILLISECONDS);
        mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_SET),
                new UInt(CDPConstants.MCI_SET_TIME_FORMAT), new Pointer(setPar));
        if (t) {
            mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_PLAY),
                    new UInt(0), new Pointer.Void());
        }
        needRedraw = true;
/*
  if(!Initialized) return;
  BOOL t=FALSE;
  if(Playing) t=TRUE;
  mciSendCommand(GetDeviceID(),MCI_STOP,0,0);
  mciSendCommand(GetDeviceID(),MCI_SEEK,MCI_SEEK_TO_START,0);
  MCI_SET_PARMS SetPar;
  SetPar.dwTimeFormat=MCI_FORMAT_TMSF;
  mciSendCommand(GetDeviceID(),MCI_SET,MCI_SET_TIME_FORMAT,(DWORD)&SetPar);
  CurrentTrack++;
  if(CurrentTrack>NumberOfTracks) CurrentTrack-=NumberOfTracks;
  MCI_SEEK_PARMS SeekPar;
  SeekPar.dwTo=CurrentTrack;
  mciSendCommand(GetDeviceID(),MCI_SEEK,MCI_TO,(DWORD)&SeekPar);
  SetPar.dwTimeFormat=MCI_FORMAT_MILLISECONDS;
  mciSendCommand(GetDeviceID(),MCI_SET,MCI_SET_TIME_FORMAT,(DWORD)&SetPar);
  if(t) mciSendCommand(GetDeviceID(),MCI_PLAY,0,0);
  NeedRedraw=TRUE;
*/
    }

    public void prev() {
        if (!initialized) {
            return;
        }
        boolean t = false;
        if (playing) {
            t = true;
        }
        mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_STOP), new UInt(0), new Pointer.Void());
        mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_SEEK), new UInt(CDPConstants.MCI_SEEK_TO_START), new Pointer.Void());
        MCI_SET_PARMS setPar = new MCI_SET_PARMS();
        setPar.dwTimeFormat.setValue(CDPConstants.MCI_FORMAT_TMSF);
        mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_SET),
                new UInt(CDPConstants.MCI_SET_TIME_FORMAT), new Pointer(setPar));
        currentTrack--;
        if (currentTrack < 1) {
            currentTrack += numberOfTracks;
        }
        MCI_SEEK_PARMS seekPar = new MCI_SEEK_PARMS();
        seekPar.dwTo.setValue(currentTrack);
        mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_SEEK),
                new UInt(CDPConstants.MCI_TO), new Pointer(seekPar));
        setPar.dwTimeFormat.setValue(CDPConstants.MCI_FORMAT_MILLISECONDS);
        mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_SET),
                new UInt(CDPConstants.MCI_SET_TIME_FORMAT), new Pointer(setPar));
        if (t) {
            mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_PLAY),
                    new UInt(0), new Pointer.Void());
        }
        needRedraw = true;

/*
  if(!Initialized) return;
  BOOL t=FALSE;
  if(Playing) t=TRUE;
  mciSendCommand(GetDeviceID(),MCI_STOP,0,0);
  mciSendCommand(GetDeviceID(),MCI_SEEK,MCI_SEEK_TO_START,0);
  MCI_SET_PARMS SetPar;
  SetPar.dwTimeFormat=MCI_FORMAT_TMSF;
  mciSendCommand(GetDeviceID(),MCI_SET,MCI_SET_TIME_FORMAT,(DWORD)&SetPar);
  CurrentTrack--;
  if(CurrentTrack<1) CurrentTrack+=NumberOfTracks;
  MCI_SEEK_PARMS SeekPar;
  SeekPar.dwTo=CurrentTrack;
  mciSendCommand(GetDeviceID(),MCI_SEEK,MCI_TO,(DWORD)&SeekPar);
  SetPar.dwTimeFormat=MCI_FORMAT_MILLISECONDS;
  mciSendCommand(GetDeviceID(),MCI_SET,MCI_SET_TIME_FORMAT,(DWORD)&SetPar);
  if(t) mciSendCommand(GetDeviceID(),MCI_PLAY,0,0);
  NeedRedraw=TRUE;
*/
    }

    private int OnWM_COMMAND(Pointer.Void hWnd, short wNotifyCode, short wID, Pointer.Void hWndCtrl) {
        switch (wID) {
            case IDStopBtn:
                stop();
                break;
            case IDPrevBtn:
                prev();
                break;
            case IDPlayBtn:
                play();
                break;
            case IDNextBtn:
                next();
                break;
            case IDDoorBtn:
                eject();
                break;
        }
        return 0;
    }

    private void Tray(UInt dwMessage, Pointer.Void hIcon) {
        NOTIFYICONDATA nid = new NOTIFYICONDATA();

        nid.cbSize.setValue(nid.getLength());
        nid.hWnd.setValue(getHWndMain().getValue());
        nid.uID.setValue(0x1000);
        nid.uFlags.setValue(CDPConstants.NIF_ICON | CDPConstants.NIF_MESSAGE | CDPConstants.NIF_TIP);
        nid.szTip.setValue("CD Player");
        nid.hIcon.setValue(hIcon.getValue());
        nid.uCallbackMessage.setValue(CDPConstants.PM_NOTIFYICON);
        shell_NotifyIcon.invoke(null, dwMessage, new Pointer(nid));
    }

    private int OnWM_CREATE(Pointer.Void hWnd) {
        Pointer.Void hRgn1 = new Pointer.Void(),
                hRgn2 = new Pointer.Void(),
                hRgn3 = createMainRegion();

        setWindowRgn.invoke(null, hWnd, hRgn3, new Bool(true));

        loadImage.invoke(hTaskbarIcon, new Argument[]{new Pointer.Void(), new Pointer(new AnsiString("demo-resources\\winplayer\\cd.ico")), new UInt(CDPConstants.IMAGE_ICON),
                new Int(0), new Int(0), new UInt(CDPConstants.LR_LOADFROMFILE)});
        if (hTaskbarIcon.isNull()) {
            messageBox.invoke(null, hWnd, new Pointer(new AnsiString("Unable to open cd.ico file")),
                    new Pointer(new AnsiString("Error")), new UInt(CDPConstants.MB_OK | CDPConstants.MB_ICONERROR));
            return -1;
        }

        imageList_Create.invoke(hImageList, new Argument[]{new Int(26), new Int(26), new UInt(CDPConstants.ILC_COLOR24),
                new Int(10), new Int(0)});
        imageList_Create.invoke(hImageListLarge, new Argument[]{new Int(79), new Int(26), new UInt(CDPConstants.ILC_COLOR24),
                new Int(2), new Int(0)});

        loadImage.invoke(hBitmapMain, new Argument[]{new Pointer.Void(), new Pointer(new AnsiString("demo-resources\\winplayer\\main.bmp")), new UInt(CDPConstants.IMAGE_BITMAP),
                new Int(0), new Int(0), new UInt(CDPConstants.LR_LOADFROMFILE)});
        if (hBitmapMain.isNull()) {
            messageBox.invoke(null, hWnd, new Pointer(new AnsiString("Unable to open main.bmp file")),
                    new Pointer(new AnsiString("Error")), new UInt(CDPConstants.MB_OK | CDPConstants.MB_ICONERROR));
            return -1;
        }

        loadImage.invoke(hBitmapInfoBg, new Argument[]{new Pointer.Void(), new Pointer(new AnsiString("demo-resources\\winplayer\\info_bg.bmp")), new UInt(CDPConstants.IMAGE_BITMAP),
                new Int(0), new Int(0), new UInt(CDPConstants.LR_LOADFROMFILE)});
        if (hBitmapInfoBg.isNull()) {
            messageBox.invoke(null, hWnd, new Pointer(new AnsiString("Unable to open info_bg.bmp file")),
                    new Pointer(new AnsiString("Error")), new UInt(CDPConstants.MB_OK | CDPConstants.MB_ICONERROR));
            return -1;
        }

        Pointer.Void hBitmap = new Pointer.Void(),
                hBitmapMask = new Pointer.Void();

        if (!registerImage("demo-resources\\winplayer\\stop_btn.bmp", hWnd, getHImageList(), hBitmap, hBitmapMask)) {
            return -1;
        }
        if (!registerImage("demo-resources\\winplayer\\p_stop_btn.bmp", hWnd, getHImageList(), hBitmap, hBitmapMask)) {
            return -1;
        }
        if (!registerImage("demo-resources\\winplayer\\prev_btn.bmp", hWnd, getHImageList(), hBitmap, hBitmapMask)) {
            return -1;
        }
        if (!registerImage("demo-resources\\winplayer\\p_prev_btn.bmp", hWnd, getHImageList(), hBitmap, hBitmapMask)) {
            return -1;
        }
        if (!registerImage("demo-resources\\winplayer\\play_btn.bmp", hWnd, getHImageList(), hBitmap, hBitmapMask)) {
            return -1;
        }
        if (!registerImage("demo-resources\\winplayer\\p_play_btn.bmp", hWnd, getHImageList(), hBitmap, hBitmapMask)) {
            return -1;
        }
        if (!registerImage("demo-resources\\winplayer\\pause_btn.bmp", hWnd, getHImageList(), hBitmap, hBitmapMask)) {
            return -1;
        }
        if (!registerImage("demo-resources\\winplayer\\p_pause_btn.bmp", hWnd, getHImageList(), hBitmap, hBitmapMask)) {
            return -1;
        }
        if (!registerImage("demo-resources\\winplayer\\next_btn.bmp", hWnd, getHImageList(), hBitmap, hBitmapMask)) {
            return -1;
        }
        if (!registerImage("demo-resources\\winplayer\\p_next_btn.bmp", hWnd, getHImageList(), hBitmap, hBitmapMask)) {
            return -1;
        }
        if (!registerImage("demo-resources\\winplayer\\eject_btn.bmp", hWnd, getHImageListLarge(), hBitmap, hBitmapMask)) {
            return -1;
        }
        if (!registerImage("demo-resources\\winplayer\\p_eject_btn.bmp", hWnd, getHImageListLarge(), hBitmap, hBitmapMask)) {
            return -1;
        }

        hWndBtn = new HWndBtn(this);
        Pointer buttonPtr = new Pointer(new AnsiString("BUTTON"));
        createWindowEx.invoke(getHWndBtn().stop, new Argument[]{new UInt(0), buttonPtr, new Pointer(new AnsiString("Stop")), new UInt(CDPConstants.WS_CHILD),
                new Int(66), new Int(59), new Int(26), new Int(26), hWnd,
                new Pointer.Void(), hInst, new Pointer.Void()});
        createWindowEx.invoke(getHWndBtn().prev, new Argument[]{new UInt(0), buttonPtr, new Pointer(new AnsiString("Prev")), new UInt(CDPConstants.WS_CHILD),
                new Int(12), new Int(59), new Int(26), new Int(26), hWnd,
                new Pointer.Void(), hInst, new Pointer.Void()});
        createWindowEx.invoke(getHWndBtn().play, new Argument[]{new UInt(0), buttonPtr, new Pointer(new AnsiString("Play")), new UInt(CDPConstants.WS_CHILD),
                new Int(39), new Int(59), new Int(26), new Int(26), hWnd,
                new Pointer.Void(), hInst, new Pointer.Void()});
        createWindowEx.invoke(getHWndBtn().next, new Argument[]{new UInt(0), buttonPtr, new Pointer(new AnsiString("Next")), new UInt(CDPConstants.WS_CHILD),
                new Int(93), new Int(59), new Int(26), new Int(26), hWnd,
                new Pointer.Void(), hInst, new Pointer.Void()});
        createWindowEx.invoke(getHWndBtn().door, new Argument[]{new UInt(0), buttonPtr, new Pointer(new AnsiString("Door")), new UInt(CDPConstants.WS_CHILD),
                new Int(126), new Int(25), new Int(79), new Int(26), hWnd,
                new Pointer.Void(), hInst, new Pointer.Void()});

        createEllipticRgn.invoke(hRgn1, new Int(0), new Int(0), new Int(26), new Int(26));
        setWindowRgn.invoke(null, getHWndBtn().stop, hRgn1, new Bool(false));
        createEllipticRgn.invoke(hRgn1, new Int(0), new Int(0), new Int(26), new Int(26));
        setWindowRgn.invoke(null, getHWndBtn().prev, hRgn1, new Bool(false));
        createEllipticRgn.invoke(hRgn1, new Int(0), new Int(0), new Int(26), new Int(26));
        setWindowRgn.invoke(null, getHWndBtn().play, hRgn1, new Bool(false));
        createEllipticRgn.invoke(hRgn1, new Int(0), new Int(0), new Int(26), new Int(26));
        setWindowRgn.invoke(null, getHWndBtn().next, hRgn1, new Bool(false));
        createRoundRectRgn.invoke(hRgn1, new Argument[]{new Int(0), new Int(0), new Int(79), new Int(26), new Int(26), new Int(26)});
        setWindowRgn.invoke(null, getHWndBtn().door, hRgn1, new Bool(false));

        setWindowLong.invoke(getHWndBtn().oldButtonProc, getHWndBtn().stop, new Int(CDPConstants.GWL_WNDPROC), getHWndBtn().newButtonProc);
        setWindowLong.invoke(null, getHWndBtn().prev, new Int(CDPConstants.GWL_WNDPROC), getHWndBtn().newButtonProc);
        setWindowLong.invoke(null, getHWndBtn().play, new Int(CDPConstants.GWL_WNDPROC), getHWndBtn().newButtonProc);
        setWindowLong.invoke(null, getHWndBtn().next, new Int(CDPConstants.GWL_WNDPROC), getHWndBtn().newButtonProc);
        setWindowLong.invoke(null, getHWndBtn().door, new Int(CDPConstants.GWL_WNDPROC), getHWndBtn().newButtonProc);

        setWindowLong.invoke(null, getHWndBtn().stop, new Int(CDPConstants.GWL_ID), new UInt(IDStopBtn));
        setWindowLong.invoke(null, getHWndBtn().prev, new Int(CDPConstants.GWL_ID), new UInt(IDPrevBtn));
        setWindowLong.invoke(null, getHWndBtn().play, new Int(CDPConstants.GWL_ID), new UInt(IDPlayBtn));
        setWindowLong.invoke(null, getHWndBtn().next, new Int(CDPConstants.GWL_ID), new UInt(IDNextBtn));
        setWindowLong.invoke(null, getHWndBtn().door, new Int(CDPConstants.GWL_ID), new UInt(IDDoorBtn));

        showWindow.invoke(null, getHWndBtn().stop, new Int(CDPConstants.SW_SHOWNA));
        updateWindow.invoke(null, getHWndBtn().stop);
        showWindow.invoke(null, getHWndBtn().prev, new Int(CDPConstants.SW_SHOWNA));
        updateWindow.invoke(null, getHWndBtn().prev);
        showWindow.invoke(null, getHWndBtn().play, new Int(CDPConstants.SW_SHOWNA));
        updateWindow.invoke(null, getHWndBtn().play);
        showWindow.invoke(null, getHWndBtn().next, new Int(CDPConstants.SW_SHOWNA));
        updateWindow.invoke(null, getHWndBtn().next);
        showWindow.invoke(null, getHWndBtn().door, new Int(CDPConstants.SW_SHOWNA));
        updateWindow.invoke(null, getHWndBtn().door);

        return 0;
    }

    private boolean registerImage(String imageName, Pointer.Void hWnd, Pointer.Void imageList, Pointer.Void hBitmap, Pointer.Void hBitmapMask) {
        loadImage.invoke(hBitmap, new Argument[]{new Pointer.Void(), new Pointer(new AnsiString(imageName)), new UInt(CDPConstants.IMAGE_BITMAP),
                new Int(0), new Int(0), new UInt(CDPConstants.LR_LOADFROMFILE)});
        if (hBitmap.isNull()) {
            messageBox.invoke(null, hWnd, new Pointer(new AnsiString("Unable to open " + imageName + " file")),
                    new Pointer(new AnsiString("Error")), new UInt(CDPConstants.MB_OK | CDPConstants.MB_ICONERROR));
            return false;
        }
        imageList_Add.invoke(null, imageList, hBitmap, hBitmapMask);
        deleteObject.invoke(null, hBitmap);
        return true;
    }

    private int prepareToShow(Pointer.Void hWnd) {
        //Show icon on taskbar
        Tray(new UInt(CDPConstants.NIM_ADD), getHTaskbarIcon());

        RECT workAreaRect = new RECT();
        WINDOWPLACEMENT windowPlacement = new WINDOWPLACEMENT();

        systemParametersInfo.invoke(null, new UInt(CDPConstants.SPI_GETWORKAREA), new UInt(0), new Pointer(workAreaRect), new UInt(0));
        windowPlacement.length.setValue(windowPlacement.getLength());
        windowPlacement.flags.setValue(CDPConstants.WPF_SETMINPOSITION);
        windowPlacement.showCmd.setValue(CDPConstants.SW_SHOWNORMAL);
        windowPlacement.ptMinPosition.x.setValue(workAreaRect.right.intValue() - 100);
        windowPlacement.ptMinPosition.y.setValue(workAreaRect.bottom.intValue() - 20);
        windowPlacement.ptMaxPosition.x.setValue(0);
        windowPlacement.ptMaxPosition.y.setValue(0);
        windowPlacement.rcNormalPosition.left.setValue(workAreaRect.right.intValue() / 2 - 103);
        windowPlacement.rcNormalPosition.top.setValue(workAreaRect.bottom.intValue() / 2 - 87);
        windowPlacement.rcNormalPosition.right.setValue(windowPlacement.rcNormalPosition.left.intValue() + WindowWidth);
        windowPlacement.rcNormalPosition.bottom.setValue(windowPlacement.rcNormalPosition.top.intValue() + WindowHeigth);
        setWindowPlacement.invoke(null, hWnd, new Pointer(windowPlacement));

        initialize();
        timerProc = new TimerProc();
        timerProc.callback();
        setTimer.invoke(IDTimer, hWnd/*new Pointer.Void()*/, new UInt32(0), new UInt32(500), timerProc);
        if (IDTimer.shortValue() == 0) {
            messageBox.invoke(null, hWnd, new Pointer(new AnsiString("Unable to set timer")), new Pointer(new AnsiString("Error")),
                    new UInt(CDPConstants.MB_OK | CDPConstants.MB_ICONERROR));
            return -1;
        }
        return 0;
    }

    private int OnWM_NCPAINT(Pointer.Void hWnd) {
        Pointer.Void hDC = new Pointer.Void(),
                hCompatibleDC = new Pointer.Void(),
                hOldBitmap = new Pointer.Void();

        getWindowDC.invoke(hDC, hWnd);
        createCompatibleDC.invoke(hCompatibleDC, hDC);
        selectObject.invoke(hOldBitmap, hCompatibleDC, getHBitmapMain());
        bitBlt.invoke(null, new Argument[]{hDC, new Int(0), new Int(0), new Int(WindowWidth), new Int(WindowHeigth),
                hCompatibleDC, new Int(0), new Int(0), new UInt(CDPConstants.SRCCOPY)});
        selectObject.invoke(null, hCompatibleDC, hOldBitmap);
        deleteDC.invoke(null, hCompatibleDC);
        releaseDC.invoke(null, hWnd, hDC);

        redrawWindow.invoke(null, getHWndBtn().stop, new Pointer.Void(),
                new Pointer.Void(), new UInt(CDPConstants.RDW_INVALIDATE));
        redrawWindow.invoke(null, getHWndBtn().prev, new Pointer.Void(),
                new Pointer.Void(), new UInt(CDPConstants.RDW_INVALIDATE));
        redrawWindow.invoke(null, getHWndBtn().play, new Pointer.Void(),
                new Pointer.Void(), new UInt(CDPConstants.RDW_INVALIDATE));
        redrawWindow.invoke(null, getHWndBtn().next, new Pointer.Void(),
                new Pointer.Void(), new UInt(CDPConstants.RDW_INVALIDATE));
        redrawWindow.invoke(null, getHWndBtn().door, new Pointer.Void(),
                new Pointer.Void(), new UInt(CDPConstants.RDW_INVALIDATE));
        return 0;
    }

    private int OnWM_PAINT(Pointer.Void hWnd) {
        Pointer.Void hOldBitmap = new Pointer.Void();
        Pointer.Void hDC = new Pointer.Void(),
                hCompatibleDC = new Pointer.Void(),
                hInfoDC = new Pointer.Void();
        PAINTSTRUCT PS = new PAINTSTRUCT();
        Pointer.Void hFont = new Pointer.Void(),
                hOldFont = new Pointer.Void();

        beginPaint.invoke(hDC, hWnd, new Pointer(PS));
        createCompatibleDC.invoke(hCompatibleDC, hDC);
        selectObject.invoke(hOldBitmap, hCompatibleDC, getHBitmapMain());

        createCompatibleDC.invoke(hInfoDC, hDC);
        selectObject.invoke(null, hInfoDC, hBitmapInfoBg);
        bitBlt.invoke(null, new Argument[]{hCompatibleDC, new Int(26), new Int(30), new Int(79), new Int(26),
                hInfoDC, new Int(0), new Int(0), new UInt(CDPConstants.SRCCOPY)});

        setBkMode.invoke(null, hCompatibleDC, new Int(CDPConstants.TRANSPARENT));
        setTextColor.invoke(null, hCompatibleDC, RGB(121, 69, 0));
        if (!noDisc) {
            createFont.invoke(hFont, new Argument[]{new Int(8), new Int(0), new Int(0), new Int(0),
                    new Int(CDPConstants.FW_MEDIUM), new Bool(false), new Bool(false), new Bool(false),
                    new UInt(CDPConstants.ANSI_CHARSET), new UInt(CDPConstants.OUT_TT_ONLY_PRECIS),
                    new UInt(CDPConstants.CLIP_DEFAULT_PRECIS), new UInt(CDPConstants.PROOF_QUALITY),
                    new UInt(CDPConstants.DEFAULT_PITCH | CDPConstants.FF_MODERN), fontName});
            selectObject.invoke(hOldFont, hCompatibleDC, hFont);

            StringBuffer buffer = new StringBuffer(50);
            buffer.append("TRACK ");
            if (currentTrack < 10) {
                buffer.append("0");
            }
            buffer.append(currentTrack);
            Pointer str = new Pointer(new AnsiString(buffer.toString()));
            textOut.invoke(null, new Argument[]{hCompatibleDC, new Int(29), new Int(34), str, new Int(str.getReferencedArgument().getLength() - 1)});

            boolean paint = false;
            if (paused) {
                if (!oddTick) {
                    paint = true;
                }
            } else {
                paint = true;
            }
            if (paint) {
                createFont.invoke(hFont, new Argument[]{new Int(8), new Int(0), new Int(0), new Int(0),
                        new Int(CDPConstants.FW_MEDIUM), new Bool(false), new Bool(false), new Bool(false),
                        new UInt(CDPConstants.ANSI_CHARSET), new UInt(CDPConstants.OUT_TT_ONLY_PRECIS),
                        new UInt(CDPConstants.CLIP_DEFAULT_PRECIS), new UInt(CDPConstants.PROOF_QUALITY),
                        new UInt(CDPConstants.DEFAULT_PITCH | CDPConstants.FF_DONTCARE), fontName});
                selectObject.invoke(null, hCompatibleDC, hFont);

                long sec = time / 1000;
                int min = (int) (sec / 60);
                sec = sec % 60;

                ((AnsiString) str.getReferencedArgument()).setValue("" + ((min < 10) ? "0" : "") + min + ":" + ((sec < 10) ? "0" : "") + sec);
                textOut.invoke(null, new Argument[]{hCompatibleDC, new Int(77), new Int(34), str, new Int(str.getReferencedArgument().getLength() - 1)});
            }
            oddTick = !oddTick;
/*





      createFont.invoke(hFont, new Argument[]{new Int(10), new Int(0), new Int(0), new Int(0),
                                              new Int(CDPConstants.FW_NORMAL), new Bool(false), new Bool(false), new Bool(false),
                                              new UInt(CDPConstants.ANSI_CHARSET), new UInt(CDPConstants.OUT_TT_ONLY_PRECIS),
                                              new UInt(CDPConstants.CLIP_DEFAULT_PRECIS), new UInt(CDPConstants.PROOF_QUALITY),
                                              new UInt(CDPConstants.DEFAULT_PITCH | CDPConstants.FF_MODERN), new Pointer.Void()});
      selectObject.invoke(null, hCompatibleDC, hFont);
      setBkColor.invoke(null, hCompatibleDC, RGB(0, 131, 0));
      setBkMode.invoke(null, hCompatibleDC, new Int(CDPConstants.OPAQUE));
      StringBuffer buffer = new StringBuffer(50);
      for(int i = 0; i < 27; i++){
        buffer.append(" ");
      }
      buffer.append("\n");
      Pointer str = new Pointer(new AnsiString(buffer.toString()));
      for(int i = 0; i < 6; i++){
        textOut.invoke(null, new Argument[]{hCompatibleDC, new Int(15), new Int(12 + i * 9), str, new Int(27)});
      }
      ((AnsiString)str.getReferencedArgument()).setValue("Track " + currentTrack + " of " + numberOfTracks);
      textOut.invoke(null, new Argument[]{hCompatibleDC, new Int(15), new Int(12), str, new Int(str.getReferencedArgument().getLength() - 1)});

      long totalSec = totalLength / 1000,
          trackSec = currentTrackLength / 1000;

      //TODO: do it rigth
      ((AnsiString)str.getReferencedArgument()).setValue("Total: " + (int)(totalSec / 60) + ":" + (int)(totalSec % 60) +
                                                         " Track: " + (int)(trackSec / 60) + ":" + (int)(trackSec % 60));
      textOut.invoke(null, new Argument[]{hCompatibleDC, new Int(15), new Int(22), str, new Int(str.getReferencedArgument().getLength() - 1)});

      createFont.invoke(hFont, new Argument[]{new Int(30), new Int(0), new Int(0), new Int(0),
                                              new Int(CDPConstants.FW_MEDIUM), new Bool(false), new Bool(false), new Bool(false),
                                              new UInt(CDPConstants.ANSI_CHARSET), new UInt(CDPConstants.OUT_TT_ONLY_PRECIS),
                                              new UInt(CDPConstants.CLIP_DEFAULT_PRECIS), new UInt(CDPConstants.PROOF_QUALITY),
                                              new UInt(CDPConstants.DEFAULT_PITCH | CDPConstants.FF_MODERN), new Pointer.Void()});
      selectObject.invoke(null, hCompatibleDC, hFont);

      long sec = time / 1000;
      ((AnsiString)str.getReferencedArgument()).setValue("" + (int)(sec / 60) + ":" + (int)(sec % 60));
      if(paused && oddTick){
        setTextColor.invoke(null, hCompatibleDC, RGB(0, 131, 0));
      } else{
        setTextColor.invoke(null, hCompatibleDC, RGB(0, 255, 0));
      }
      oddTick = !oddTick;
      textOut.invoke(null, new Argument[]{hCompatibleDC, new Int(57), new Int(37), str, new Int(str.getReferencedArgument().getLength() - 1)});
      setTextColor.invoke(null, hCompatibleDC, RGB(0, 255, 0));
*/
        } else {
            createFont.invoke(hFont, new Argument[]{new Int(9), new Int(0), new Int(0), new Int(0),
                    new Int(CDPConstants.FW_SEMIBOLD), new Bool(false), new Bool(false), new Bool(false),
                    new UInt(CDPConstants.ANSI_CHARSET), new UInt(CDPConstants.OUT_TT_ONLY_PRECIS),
                    new UInt(CDPConstants.CLIP_DEFAULT_PRECIS), new UInt(CDPConstants.PROOF_QUALITY),
                    new UInt(CDPConstants.DEFAULT_PITCH | CDPConstants.FF_SCRIPT), fontName});
            selectObject.invoke(hOldFont, hCompatibleDC, hFont);
            textOut.invoke(null, new Argument[]{hCompatibleDC, new Int(43), new Int(33), new Pointer(new AnsiString("No Disc")), new Int(7)});
        }

        bitBlt.invoke(null, new Argument[]{hDC, new Int(0), new Int(0), new Int(WindowWidth), new Int(WindowHeigth),
                hCompatibleDC, new Int(0), new Int(0), new UInt(CDPConstants.SRCCOPY)});
        selectObject.invoke(null, hCompatibleDC, hOldBitmap);
        selectObject.invoke(null, hCompatibleDC, hOldFont);
        deleteDC.invoke(null, hCompatibleDC);
        deleteDC.invoke(null, hInfoDC);
        deleteObject.invoke(null, hFont);
        endPaint.invoke(null, hWnd, new Pointer(PS));
        return 0;
    }

    private int OnWM_NCHITTEST(Pointer.Void hWnd, short xPos, short yPos) {
        return 2;
    }

    private void OnWM_NCLBUTTONDOWN(Pointer.Void hWnd, POINT pts) {
        screenToClient.invoke(null, hWnd, new Pointer(pts));
        if ((pts.x.intValue() >= 197) && (pts.x.intValue() <= 206) && (pts.y.intValue() >= 6) && (pts.y.intValue() <= 15)) {
            postMessage.invoke(null, hWnd, new UInt(CDPConstants.WM_CLOSE), new UInt(0), new UInt(0));
        }

        if ((pts.x.intValue() >= 180) && (pts.x.intValue() <= 189) && (pts.y.intValue() >= 6) && (pts.y.intValue() <= 15)) {
            showWindow.invoke(null, hWnd, new Int(CDPConstants.SW_MINIMIZE));
            showWindow.invoke(null, hWnd, new Int(CDPConstants.SW_HIDE));
        }
    }

    private int OnPM_NOTIFYICON(Pointer.Void hWnd, int notifyCode) {
        Bool bResult = new Bool();
        switch (notifyCode) {
            case CDPConstants.WM_LBUTTONUP:
            case CDPConstants.WM_RBUTTONUP:
                isIconic.invoke(bResult, getHWndMain());
                if (!bResult.getValue()) {
                    setForegroundWindow.invoke(null, hWnd);
                }
                break;
            case CDPConstants.WM_LBUTTONDBLCLK:
                isIconic.invoke(bResult, getHWndMain());
                if (bResult.getValue()) {
                    showWindow.invoke(null, hWnd, new Int(CDPConstants.SW_RESTORE));
                    setForegroundWindow.invoke(null, hWnd);
                } else {
                    showWindow.invoke(null, hWnd, new Int(CDPConstants.SW_MINIMIZE));
                    showWindow.invoke(null, hWnd, new Int(CDPConstants.SW_HIDE));

                }
        }
        return 0;
    }

    private void makeDefault() {
        /*
        HKEY hKey;
        if(RegOpenKeyEx(HKEY_CLASSES_ROOT,"AudioCD\\shell\\play\\command",
                        0,KEY_SET_VALUE,&hKey)!=ERROR_SUCCESS){
          MessageBox(hWndMain,"Unable to open registry key","Error",MB_OK|MB_ICONERROR);
          return;
        }
        char CurrentDir[301];
        GetCurrentDirectory(300,CurrentDir);
        if(strlen(CurrentDir)<4) return;
        strcat(CurrentDir,"\\CDP");
        int Index=0;
        char ValueName[101];
        DWORD ValueNameLen=100;
        char ValueData[101];
        DWORD ValueDataLen=100;
        DWORD ValueType;
        while(RegEnumValue(hKey,Index,ValueName,&ValueNameLen,NULL,&ValueType,(unsigned char *)ValueData,&ValueDataLen)!=ERROR_NO_MORE_ITEMS){
          Index++;
          if(ValueType==REG_SZ)
            if(!strcmp(ValueData,CurrentDir)) return;
        }
        if(MessageBox(hWndMain,"Do you want to make this Audio CD Player the default player?",
                      "CD Player",MB_YESNO|MB_ICONQUESTION)==IDYES){
          if(RegSetValueEx(hKey,NULL,0,REG_SZ,CurrentDir,strlen(CurrentDir)+1)!=ERROR_SUCCESS)
            MessageBox(hWndMain,"Unable to set registry value","Error",MB_OK|MB_ICONERROR);
          RegCloseKey(hKey);
          MessageBox(hWndMain,"Now CD Player is the default player","CD Player",MB_OK|MB_ICONINFORMATION);
        }
        */
    }

    private Pointer.Void createMainRegion() {
        POINT[] lppt = new POINT[48];
        for (int i = 0; i < lppt.length; i++) {
            lppt[i] = new POINT();
        }
        int idx = 0;
        lppt[idx].x.setValue(5);
        lppt[idx++].y.setValue(0);
        lppt[idx].x.setValue(5);
        lppt[idx++].y.setValue(1);
        lppt[idx].x.setValue(3);
        lppt[idx++].y.setValue(1);
        lppt[idx].x.setValue(3);
        lppt[idx++].y.setValue(2);
        lppt[idx].x.setValue(2);
        lppt[idx++].y.setValue(2);
        lppt[idx].x.setValue(2);
        lppt[idx++].y.setValue(3);
        lppt[idx].x.setValue(1);
        lppt[idx++].y.setValue(3);
        lppt[idx].x.setValue(1);
        lppt[idx++].y.setValue(5);
        lppt[idx].x.setValue(0);
        lppt[idx++].y.setValue(5);

        lppt[idx].x.setValue(0);
        lppt[idx++].y.setValue(88);
        lppt[idx].x.setValue(1);
        lppt[idx++].y.setValue(88);
        lppt[idx].x.setValue(1);
        lppt[idx++].y.setValue(90);
        lppt[idx].x.setValue(2);
        lppt[idx++].y.setValue(90);
        lppt[idx].x.setValue(2);
        lppt[idx++].y.setValue(91);
        lppt[idx].x.setValue(3);
        lppt[idx++].y.setValue(91);
        lppt[idx].x.setValue(3);
        lppt[idx++].y.setValue(92);
        lppt[idx].x.setValue(5);
        lppt[idx++].y.setValue(92);
        lppt[idx].x.setValue(5);
        lppt[idx++].y.setValue(93);

        lppt[idx].x.setValue(127);
        lppt[idx++].y.setValue(93);
        lppt[idx].x.setValue(127);
        lppt[idx++].y.setValue(92);
        lppt[idx].x.setValue(129);
        lppt[idx++].y.setValue(92);
        lppt[idx].x.setValue(129);
        lppt[idx++].y.setValue(91);
        lppt[idx].x.setValue(130);
        lppt[idx++].y.setValue(91);
        lppt[idx].x.setValue(130);
        lppt[idx++].y.setValue(90);
        lppt[idx].x.setValue(131);
        lppt[idx++].y.setValue(90);
        lppt[idx].x.setValue(131);
        lppt[idx++].y.setValue(88);
        lppt[idx].x.setValue(132);
        lppt[idx++].y.setValue(88);

        lppt[idx].x.setValue(132);
        lppt[idx++].y.setValue(66);
        lppt[idx].x.setValue(133);
        lppt[idx++].y.setValue(66);
        lppt[idx].x.setValue(133);
        lppt[idx++].y.setValue(64);
        lppt[idx].x.setValue(134);
        lppt[idx++].y.setValue(64);
        lppt[idx].x.setValue(135);
        lppt[idx++].y.setValue(63);
        lppt[idx].x.setValue(136);
        lppt[idx++].y.setValue(63);
        lppt[idx].x.setValue(137);
        lppt[idx++].y.setValue(62);

        lppt[idx].x.setValue(214);
        lppt[idx++].y.setValue(62);
        lppt[idx].x.setValue(215);
        lppt[idx++].y.setValue(61);
        lppt[idx].x.setValue(261);
        lppt[idx++].y.setValue(61);
        lppt[idx].x.setValue(217);
        lppt[idx++].y.setValue(60);
        lppt[idx].x.setValue(218);
        lppt[idx++].y.setValue(59);
        lppt[idx].x.setValue(218);
        lppt[idx++].y.setValue(58);
        lppt[idx].x.setValue(219);
        lppt[idx++].y.setValue(57);

        lppt[idx].x.setValue(219);
        lppt[idx++].y.setValue(5);
        lppt[idx].x.setValue(218);
        lppt[idx++].y.setValue(4);
        lppt[idx].x.setValue(218);
        lppt[idx++].y.setValue(3);
        lppt[idx].x.setValue(217);
        lppt[idx++].y.setValue(2);
        lppt[idx].x.setValue(216);
        lppt[idx++].y.setValue(1);
        lppt[idx].x.setValue(215);
        lppt[idx++].y.setValue(1);
        lppt[idx].x.setValue(214);
        lppt[idx++].y.setValue(0);
        ///////////*************
        int polyCounts = idx;

        Pointer.Void hRGN = new Pointer.Void();
        createPolyPolygonRgn.invoke(hRGN, new Pointer.Const(new ArrayArgument(lppt)),
                new Pointer.Const(new UInt32(polyCounts)),
                new UInt32(1), new UInt32(CDPConstants.WINDING));
        return hRGN;
    }


    private class MainWndProc extends Callback {
        private Pointer.Void hWnd = new Pointer.Void();
        private UInt32 uMsg = new UInt32();
        private UInt32 wParam = new UInt32();
        private Int32 lParam = new Int32();
        private UInt32 lResult = new UInt32();

        public MainWndProc() {
            initialize(lResult, new Argument[]{hWnd, uMsg, wParam, lParam});
        }


        public void callback() {
            switch (uMsg.intValue()) {
                case CDPConstants.WM_CREATE:
                    lResult.setValue(OnWM_CREATE(hWnd));
                    break;
                case CDPConstants.PM_NOTIFYICON:
                    lResult.setValue(OnPM_NOTIFYICON(hWnd, lParam.intValue()));
                    break;
                case CDPConstants.WM_PAINT:
                    lResult.setValue(OnWM_PAINT(hWnd));
                    break;
                case CDPConstants.WM_NCPAINT:
                    lResult.setValue(OnWM_NCPAINT(hWnd));
                    break;
                case CDPConstants.WM_NCHITTEST:
                    lResult.setValue(OnWM_NCHITTEST(hWnd, LOWORD(lParam.intValue()), HIWORD(lParam.intValue())));
                    break;
                case CDPConstants.WM_COMMAND:
                    lResult.setValue(OnWM_COMMAND(hWnd, HIWORD(wParam.intValue()), LOWORD(wParam.intValue()), new Pointer.Void(lParam.intValue())));
                    break;
                case CDPConstants.WM_DESTROY:
                    Tray(new UInt(CDPConstants.NIM_DELETE), new Pointer.Void());//Delete taskbar icon
                    imageList_Destroy.invoke(null, getHImageList()); //Delete imagelist
                    imageList_Destroy.invoke(null, getHImageListLarge()); //Delete imagelist
                    deleteObject.invoke(null, getHBitmapMain()); //Delete bitmap
                    deleteObject.invoke(null, hBitmapInfoBg); //Delete bitmap
                    deleteObject.invoke(null, getHTaskbarIcon()); //Delete icon
                    killTimer.invoke(null, hWnd/*new Pointer.Void()*/, IDTimer); //Delete timer
                    deinitialize();
                    postQuitMessage.invoke(null, new Int(0));
                    lResult.setValue(0);
                    break;
                case CDPConstants.WM_NCLBUTTONDOWN:
                    OnWM_NCLBUTTONDOWN(hWnd, MAKEPOINT(lParam.intValue()));
                default:
                    defWindowProc.invoke(lResult, hWnd, uMsg, wParam, lParam);
                    break;
            }
        }
    }

    private class TimerProc extends Callback {
        private Pointer.Void hWND; // handle to window
        private UInt32 uMsg;       // WM_TIMER message
        private UInt32 idEvent;    // timer identifier
        private Int32 dwTime;      // current system time

        private MCI_STATUS_PARMS statusParams;
        private long prevTime = 0;
        private RECT rect;

        public TimerProc() {
            statusParams = new MCI_STATUS_PARMS();
            rect = new RECT();
            hWND = new Pointer.Void();
            uMsg = new UInt32();
            idEvent = new UInt32();
            dwTime = new Int32();
            initialize(null, new Argument[]{hWND, uMsg, idEvent, dwTime});
        }

        public void callback() {
            statusParams.dwItem.setValue(CDPConstants.MCI_STATUS_MODE);
            mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_STATUS),
                    new UInt(CDPConstants.MCI_STATUS_ITEM), new Pointer(statusParams));
            boolean oldDoorIsOpen = doorIsOpen;
            playing = doorIsOpen = false;
            switch (statusParams.dwReturn.intValue()) {
                case CDPConstants.MCI_MODE_PLAY:
                    playing = true;
                    break;
                case CDPConstants.MCI_MODE_OPEN:
                    doorIsOpen = true;
                    break;
            }
            if (oldDoorIsOpen != doorIsOpen) {
                stop();
            }
            noDisc = doorIsOpen;
            statusParams.dwItem.setValue(CDPConstants.MCI_CDA_STATUS_TYPE_TRACK);
            statusParams.dwTrack.setValue(1);
            mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_STATUS),
                    new UInt(CDPConstants.MCI_STATUS_ITEM | CDPConstants.MCI_TRACK), new Pointer(statusParams));
            if (statusParams.dwReturn.intValue() == CDPConstants.MCI_CDA_TRACK_OTHER) {
                noDisc = true;
            }

            statusParams.dwItem.setValue(CDPConstants.MCI_STATUS_NUMBER_OF_TRACKS);
            mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_STATUS),
                    new UInt(CDPConstants.MCI_STATUS_ITEM), new Pointer(statusParams));
            numberOfTracks = statusParams.dwReturn.intValue();

            statusParams.dwItem.setValue(CDPConstants.MCI_STATUS_CURRENT_TRACK);
            mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_STATUS),
                    new UInt(CDPConstants.MCI_STATUS_ITEM), new Pointer(statusParams));
            currentTrack = statusParams.dwReturn.intValue();

            statusParams.dwItem.setValue(CDPConstants.MCI_STATUS_LENGTH);
            mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_STATUS),
                    new UInt(CDPConstants.MCI_STATUS_ITEM), new Pointer(statusParams));
            totalLength = statusParams.dwReturn.intValue();

            statusParams.dwItem.setValue(CDPConstants.MCI_STATUS_LENGTH);
            statusParams.dwTrack.setValue(currentTrack);
            mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_STATUS),
                    new UInt(CDPConstants.MCI_STATUS_ITEM | CDPConstants.MCI_TRACK), new Pointer(statusParams));
            currentTrackLength = statusParams.dwReturn.intValue();

            statusParams.dwItem.setValue(CDPConstants.MCI_STATUS_POSITION);
            mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_STATUS),
                    new UInt(CDPConstants.MCI_STATUS_ITEM), new Pointer(statusParams));

            long diskTime = statusParams.dwReturn.longValue();

            statusParams.dwItem.setValue(CDPConstants.MCI_STATUS_POSITION);
            statusParams.dwTrack.setValue(currentTrack);
            mciSendCommand.invoke(null, getDeviceID(), new UInt(CDPConstants.MCI_STATUS),
                    new UInt(CDPConstants.MCI_STATUS_ITEM | CDPConstants.MCI_TRACK), new Pointer(statusParams));
            long trackBeginningTime = statusParams.dwReturn.longValue();
            time = diskTime - trackBeginningTime;

            if (((time / 1000 - prevTime) > 0) && playing) {
                needRedraw = true;
            }
            prevTime = time / 1000;
            if (paused) {
                needRedraw = true;
            }
            if (needRedraw) {
                rect.top.setValue(0);
                rect.left.setValue(0);
                rect.bottom.setValue(WindowHeigth);
                rect.right.setValue(WindowWidth);
                invalidateRect.invoke(null, getHWndMain(), new Pointer(rect), new Bool(false));
                needRedraw = false;
            }
        }

/*
VOID CALLBACK TimerProc(HWND hWnd,UINT uMsg,UINT idEvent,DWORD dwTime)
{
//  hWnd - handle of window for timer messages
//  uMsg - WM_TIMER message
//  idEvent - timer identifier
//  dwTime - current system time
UNREFERENCED_PARAMETER(hWnd);
UNREFERENCED_PARAMETER(uMsg);
UNREFERENCED_PARAMETER(idEvent);
UNREFERENCED_PARAMETER(dwTime);

  static MCI_STATUS_PARMS StatusPar;
  StatusPar.dwItem=MCI_STATUS_MODE;
  mciSendCommand(CD.GetDeviceID(),MCI_STATUS,MCI_STATUS_ITEM,(DWORD)&StatusPar);
  BOOL OldDoorIsOpen=CD.DoorIsOpen;
  CD.Playing=CD.DoorIsOpen=FALSE;
  switch(StatusPar.dwReturn){
    case MCI_MODE_PLAY: CD.Playing=TRUE;break;
    case MCI_MODE_OPEN: CD.DoorIsOpen=TRUE;break;
  }
  if(OldDoorIsOpen!=CD.DoorIsOpen) CD.Stop();
  CD.NoDisc=CD.DoorIsOpen;
  StatusPar.dwItem=MCI_CDA_STATUS_TYPE_TRACK;
  StatusPar.dwTrack=1;
  mciSendCommand(CD.GetDeviceID(),MCI_STATUS,MCI_STATUS_ITEM|MCI_TRACK,(DWORD)&StatusPar);
  if(StatusPar.dwReturn==MCI_CDA_TRACK_OTHER) CD.NoDisc=TRUE;

  StatusPar.dwItem=MCI_STATUS_NUMBER_OF_TRACKS;
  mciSendCommand(CD.GetDeviceID(),MCI_STATUS,MCI_STATUS_ITEM,(DWORD)&StatusPar);
  CD.NumberOfTracks=StatusPar.dwReturn;//
  StatusPar.dwItem=MCI_STATUS_CURRENT_TRACK;
  mciSendCommand(CD.GetDeviceID(),MCI_STATUS,MCI_STATUS_ITEM,(DWORD)&StatusPar);
  CD.CurrentTrack=StatusPar.dwReturn;//
  StatusPar.dwItem=MCI_STATUS_LENGTH;
  mciSendCommand(CD.GetDeviceID(),MCI_STATUS,MCI_STATUS_ITEM,(DWORD)&StatusPar);
  CD.TotalLength=StatusPar.dwReturn;//
  StatusPar.dwItem=MCI_STATUS_LENGTH;
  StatusPar.dwTrack=CD.CurrentTrack;
  mciSendCommand(CD.GetDeviceID(),MCI_STATUS,MCI_STATUS_ITEM|MCI_TRACK,(DWORD)&StatusPar);
  CD.CurrentTrackLength=StatusPar.dwReturn;//

  StatusPar.dwItem=MCI_STATUS_POSITION;
  mciSendCommand(CD.GetDeviceID(),MCI_STATUS,MCI_STATUS_ITEM,(DWORD)&StatusPar);
  long DiscTime=StatusPar.dwReturn;
  StatusPar.dwItem=MCI_STATUS_POSITION;
  StatusPar.dwTrack=CD.CurrentTrack;
  mciSendCommand(CD.GetDeviceID(),MCI_STATUS,MCI_STATUS_ITEM|MCI_TRACK,(DWORD)&StatusPar);
  long TrackBeginningTime=StatusPar.dwReturn;//
  CD.Time=DiscTime-TrackBeginningTime;//

  static long PrevTime=0;
  if(((CD.Time/1000-PrevTime)>0)&&(CD.Playing)) NeedRedraw=TRUE;
  if(CD.Paused) NeedRedraw=TRUE;
  PrevTime=CD.Time/1000;
  if(NeedRedraw){
    RECT R;
    R.top=R.left=0;R.bottom=70;R.right=WindowWidth;
    InvalidateRect(hWndMain,&R,FALSE);
    NeedRedraw=FALSE;
  }
}
*/
    }

    private static UInt RGB(int r, int g, int b) {
        return new UInt((r & 0xFF) | ((g & 0xFF) << 8) | ((b & 0xFF) << 16));
    }

    private static short LOWORD(int word) {
        return (short) (word & 0xFFFF);
    }

    private static short HIWORD(int word) {
        return (short) (((word >> 16) & 0xFFFF));
    }

    private static POINT MAKEPOINT(int param) {
        POINT point = new POINT();
        point.x.setValue(LOWORD(param));
        point.y.setValue(HIWORD(param));
        return point;
    }

    public int winMain() {
        Pointer.Void hWnd = new Pointer.Void();
        Pointer wndClassName = new Pointer(new AnsiString("CDPlayerWindowClass"));
        Pointer wndName = new Pointer(new AnsiString("CD Player"));
        findWindow.invoke(hWnd, wndClassName, wndName);
        if (!hWnd.isNull()) {
            Bool bool = new Bool();
            isIconic.invoke(bool, hWnd);
            if (bool.getValue()) {
                setForegroundWindow.invoke(null, hWnd);
                return 0;
            }
        }

        MSG msg = new MSG();
        if (!registered) {
            WNDCLASS wndClass = new WNDCLASS(new MainWndProc());
            wndClass.style.setValue(0);
            wndClass.cbClsExtra.setValue(0);
            wndClass.cbWndExtra.setValue(0);
            wndClass.hInstance.setValue(hInst.getValue());
            loadIcon.invoke(wndClass.hIcon, new Pointer.Void(), new Pointer.Void(CDPConstants.IDI_APPLICATION));
            loadCursor.invoke(wndClass.hCursor, new Pointer.Void(), new Pointer.Void(CDPConstants.IDC_ARROW));
            getStockObject.invoke(wndClass.hbrBackground, new Int(CDPConstants.WHITE_BRUSH));
            wndClass.lpszMenuName.setValue("MainMenu");
            wndClass.lpszClassName.setValue(wndClassName.getReferencedArgument().toString());
            Bool regResult = new Bool();
            registerClass.invoke(regResult, new Pointer(wndClass));
            if (!regResult.getValue()) {
                return 0;
            }
            registered = true;
        }

        createWindowEx.invoke(hWndMain, new Argument[]{new UInt(CDPConstants.WS_EX_TOOLWINDOW), wndClassName, wndName,
                new UInt(CDPConstants.WS_POPUP), new Int(CDPConstants.CW_USEDEFAULT),
                new Int(CDPConstants.CW_USEDEFAULT), new Int(WindowWidth), new Int(WindowHeigth),
                new Pointer.Void(), new Pointer.Void(), hInst, new Pointer.Void()});
        // If the main window cannot be created, terminate
        // the application.
        if (hWndMain.isNull()) {
            return 0;
        }
        initCommonControls.invoke(null);
        prepareToShow(getHWndMain());
        makeDefault();

        // Show the window and paint its contents.
        showWindow.invoke(null, getHWndMain(), new Int(CDPConstants.SW_SHOWNA));
        updateWindow.invoke(null, getHWndMain());

        Pointer msgPointer = new Pointer(msg);
        Int32 getMR = new Int32();
        while (true) {
            getMessage.invoke(getMR, msgPointer, getHWndMain()/*new Pointer.Void()*/, new UInt32(), new UInt32());
            if (!getMR.booleanValue() || getMR.intValue() == -1) {
                break;
            }
            if (msg.message.intValue() == 0x113) {
                timerProc.callback();
                continue;
            }
            translateMessage.invoke(null, msgPointer);

//      if(msg.message.intValue() == 0x0113){
//        //System.out.println("lparam: " + msg.lParam + "   timerProc: " + timerProc.thunkAddress);
//        timerProc.callback();
//      }else{
/*
      case 0x0113:
      //WM_TIMER                        0x0113
        System.out.println("lparam: " + lParam + "   timerProc: " + timerProc.thunkAddress);
        defWindowProc.invoke(lResult, hWnd, uMsg, wParam, lParam);
        break;
*/

            dispatchMessage.invoke(null, msgPointer);
//      }
        }

        return msg.wParam.intValue();
    }

    private static class MSG extends Structure {
        public Pointer.Void hwnd;
        public UInt32 message;
        public UInt32 wParam;
        public Int32 lParam;
        public UInt16 time;
        public POINT pt;

        public MSG() {
            this.hwnd = new Pointer.Void();
            this.message = new UInt32();
            this.wParam = new UInt32();
            this.lParam = new Int32();
            this.time = new UInt16();
            this.pt = new POINT();

            initialize(new Argument[]{hwnd, message, wParam, lParam, time, pt});
        }
    }

    private static class WNDCLASS extends Structure {
        private UInt32 style = new UInt32();
        private Callback lpfnWndProc;
        private Int32 cbClsExtra = new Int32();
        private Int32 cbWndExtra = new Int32();
        private Pointer.Void hInstance = new Pointer.Void();
        private Pointer.Void hIcon = new Pointer.Void();
        private Pointer.Void hCursor = new Pointer.Void();
        private Pointer.Void hbrBackground = new Pointer.Void();
        private AnsiString lpszMenuName = new AnsiString();
        private AnsiString lpszClassName = new AnsiString();

        public WNDCLASS(Callback windowProc) {
            style.setValue(3); // CS_HREDRAW | CS_VREDRAW
            lpfnWndProc = windowProc;
            cbClsExtra.setValue(0);
            cbWndExtra.setValue(0);
            hInstance.setValue(0);
            hIcon.setValue(0);
            hCursor.setValue(0);
            initialize(new Argument[]{style, lpfnWndProc, cbClsExtra, cbWndExtra, hInstance, hIcon, hCursor, hbrBackground, new Pointer(lpszMenuName), new Pointer(lpszClassName)});
        }

/*
typedef struct _WNDCLASS {
    UINT       style;
    WNDPROC    lpfnWndProc;
    int        cbClsExtra;
    int        cbWndExtra;
    HINSTANCE  hInstance;
    HICON      hIcon;
    HCURSOR    hCursor;
    HBRUSH     hbrBackground;
    LPCTSTR    lpszMenuName;
    LPCTSTR    lpszClassName;
} WNDCLASS, *PWNDCLASS;
*/
    }

    private static class MCI_STATUS_PARMS extends Structure {
/*
typedef struct {
    DWORD_PTR dwCallback;
    DWORD     dwReturn;
    DWORD     dwItem;
    DWORD     dwTrack;
} MCI_STATUS_PARMS;
*/
        public Pointer dwCallback;
        public UInt dwReturn;
        public UInt dwItem;
        public UInt dwTrack;

        public MCI_STATUS_PARMS() {
            dwCallback = new Pointer(new UInt32());
            dwReturn = new UInt();
            dwItem = new UInt();
            dwTrack = new UInt();

            initialize(new Argument[]{dwCallback, dwReturn, dwItem, dwTrack});
        }
    }

    private static class MCI_OPEN_PARMS extends Structure {
/*
    typedef struct {
        DWORD_PTR    dwCallback;
        MCIDEVICEID  wDeviceID;
        LPCSTR       lpstrDeviceType;
        LPCSTR       lpstrElementName;
        LPCSTR       lpstrAlias;
    } MCI_OPEN_PARMS;
*/
        public Pointer dwCallback;
        public UInt wDeviceID;
        public Pointer.Void lpstrDeviceType;
        public Pointer lpstrElementName;
        public Pointer lpstrAlias;

        public MCI_OPEN_PARMS() {
            dwCallback = new Pointer(new UInt32());
            wDeviceID = new UInt();
            lpstrDeviceType = new Pointer.Void();
            lpstrElementName = new Pointer(new AnsiString());
            lpstrAlias = new Pointer(new AnsiString());

            initialize(new Argument[]{dwCallback, wDeviceID, lpstrDeviceType, lpstrElementName, lpstrAlias});
        }

    }

    private static class MCI_SET_PARMS extends Structure {
/*
  typedef struct {
      DWORD_PTR dwCallback;
      DWORD     dwTimeFormat;
      DWORD     dwAudio;
  } MCI_SET_PARMS;
*/
        public Pointer dwCallback;
        public UInt dwTimeFormat;
        public UInt dwAudio;

        public MCI_SET_PARMS() {
            dwCallback = new Pointer(new UInt32());
            dwTimeFormat = new UInt();
            dwAudio = new UInt();

            initialize(new Argument[]{dwCallback, dwTimeFormat, dwAudio});
        }

    }

    private static class MCI_SEEK_PARMS extends Structure {
/*
typedef struct {
    DWORD_PTR dwCallback;
    DWORD     dwTo;
} MCI_SEEK_PARMS;
*/
        public Pointer dwCallback;
        public UInt dwTo;

        public MCI_SEEK_PARMS() {
            dwCallback = new Pointer(new UInt32());
            dwTo = new UInt();

            initialize(new Argument[]{dwCallback, dwTo});
        }
    }

    /**
     * This a wrapper class for system defined structure NOTIFYICONDATA
     */
    private static class NOTIFYICONDATA extends Structure {
        public UInt cbSize;
        public Pointer.Void hWnd;
        public UInt uID;
        public UInt uFlags;
        public UInt uCallbackMessage;
        public Pointer.Void hIcon;
        public AnsiString szTip;
        public UInt dwState;
        public UInt dwStateMask;
        public AnsiString szInfo;
        public IconDataUnion union;
        public AnsiString szInfoTitle;
        public UInt dwInfoFlags;

        public NOTIFYICONDATA() {
            cbSize = new UInt();
            hWnd = new Pointer.Void();
            uID = new UInt();
            uFlags = new UInt();
            uCallbackMessage = new UInt();
            hIcon = new Pointer.Void();
            szTip = new AnsiString("", 127);
            dwState = new UInt();
            dwStateMask = new UInt();
            szInfo = new AnsiString("", 255);
            union = new IconDataUnion();
            szInfoTitle = new AnsiString("", 63);
            dwInfoFlags = new UInt();

            initialize(new Argument[]{cbSize, hWnd, uID, uFlags, uCallbackMessage, hIcon, szTip,
                    dwState, dwStateMask, szInfo, union, szInfoTitle, dwInfoFlags});
        }
    }

    /**
     * Class that is used to perform union functionality. It is used in NOTIFYICONDATA structure
     */
    private static class IconDataUnion extends Union {
        public UInt uTimeout;
        public UInt uVersion;

        public IconDataUnion() {
            uTimeout = new UInt();
            uVersion = new UInt();
            initialize(new Argument[]{uTimeout, uVersion});
        }
    }

    private static class WINDOWPLACEMENT extends Structure {
/*
typedef struct _WINDOWPLACEMENT {
    UINT  length;
    UINT  flags;
    UINT  showCmd;
    POINT ptMinPosition;
    POINT ptMaxPosition;
    RECT  rcNormalPosition;
} WINDOWPLACEMENT;
*/
        public UInt length;
        public UInt flags;
        public UInt showCmd;
        public POINT ptMinPosition;
        public POINT ptMaxPosition;
        public RECT rcNormalPosition;

        public WINDOWPLACEMENT() {
            length = new UInt();
            flags = new UInt();
            showCmd = new UInt();
            ptMinPosition = new POINT();
            ptMaxPosition = new POINT();
            rcNormalPosition = new RECT();

            initialize(new Argument[]{length, flags, showCmd, ptMinPosition, ptMaxPosition, rcNormalPosition});
        }

    }

    private static class POINT extends Structure {
        public Int32 x;
        public Int32 y;

        public POINT() {
            x = new Int32();
            y = new Int32();
            initialize(new Argument[]{x, y});
        }
    }
}
